//---------------------------------------------------------------------------------------------
// File EDITOR2.CPP
//---------------------------------------------------------------------------------------------
#define INCL_WIN
#define INCL_GPI

#include <os2.h>
#include <stdio.h>
#include <string.h>
#include "editor2.h"

//---------------------------------------------------------------------------------------------
// Prototypes
//---------------------------------------------------------------------------------------------
MRESULT EXPENTRY ClientWndProc ( HWND, ULONG, MPARAM, MPARAM );    // Window procedure
MRESULT EXPENTRY NewFrameProc  ( HWND, ULONG ,MPARAM, MPARAM ); // subclass framewindow
MRESULT EXPENTRY NewMLEProc    ( HWND, ULONG ,MPARAM, MPARAM ); // subclass MLEwindow

void OpenFile      ( PSZ );
void OpenFileDlg   ( HWND );
void SaveFile      ( PSZ );
void SaveasFileDlg ( HWND );
//---------------------------------------------------------------------------------------------
// Global variables
//---------------------------------------------------------------------------------------------
HAB   hab;
HWND  hwndFrame,        // Frame
      hwndClient,       // Main client
      hwndStatus,       // Statusbar
      hwndToolbar,      // Toolbar
      hwndMenu,         // MainMenu
      hwndMLE;          // MLE

PFNWP pfnwOldFrameProc; // Pointer to normal Frame routine in kernel for subclassing
PFNWP pfnwOldMLEProc;   // Pointer to normal MLE   routine in kernel for subclassing


//---------------------------------------------------------------------------------------------
// Main procedure  (parameters for drop on icon)
//---------------------------------------------------------------------------------------------
main(int argc, char *argv[])
     {
     HMQ   hmq;
     QMSG  qmsg;
     ULONG flFrameFlags = FCF_TITLEBAR |FCF_SYSMENU |FCF_SIZEBORDER |FCF_MINMAX |FCF_TASKLIST;
     CHAR  szClient[] = "CLIENT";

     hab = WinInitialize (0);
     hmq = WinCreateMsgQueue (hab, 0);

     WinRegisterClass (hab, szClient, ClientWndProc, CS_SIZEREDRAW, 0);

     // Create Frame window
     hwndFrame = WinCreateStdWindow (HWND_DESKTOP,
                                     WS_VISIBLE,
                                     &flFrameFlags,
                                     szClient,
                                     "Untitled",
                                     0,
                                     NULLHANDLE,
                                     MAINMENU,
                                     &hwndClient);

      // Create statusbar window
      hwndStatus= WinCreateWindow(hwndFrame,
                                  WC_STATIC,
                                 " StatusBar",
                                  SS_TEXT| DT_VCENTER | WS_VISIBLE
                                  ,0, 0, 0, 0,       // client window has no size or position at this point
                                  hwndFrame,         // Owner handle (Client area)
                                  HWND_TOP,          // Z-order ontop
                                  STATUSBAR,         // Window ID
                                  0,                 // Control
                                  0);                // Presentation Parameters

     // Create MLE window
     hwndMLE = WinCreateWindow(hwndClient,           // Parent handle (Client area)
                               WC_MLE,               // Window class (NLE)
                               NULL,                 // Window header text
                               WS_VISIBLE|
                               MLS_WORDWRAP|
                               MLS_BORDER|
                               MLS_VSCROLL|
                               MLS_HSCROLL,          //Style flags
                               0, 0, 0, 0,           // client window has no size or position at this point
                               hwndClient,           // Owner handle (Client area)
                               HWND_TOP,             // Z-order ontop
                               MAINMLE,              // Window ID (Main MLE resource ID)
                               0,                    // Control
                               0);                   // Presentation Parameters
     //---------------------------------------------------------------------------------------------
     // Subclassing normal window proc & MLE window proc
     //---------------------------------------------------------------------------------------------
     pfnwOldFrameProc = WinSubclassWindow(hwndFrame,NewFrameProc);  // subclass Framewin
     pfnwOldMLEProc   = WinSubclassWindow(hwndMLE,NewMLEProc);      // Subclass mainMLE (drag drop)
     WinSetWindowULong(hwndFrame,QWL_USER,(ULONG)pfnwOldFrameProc); // Pointer to oldwinproc in winword
     WinSetWindowULong(hwndMLE,QWL_USER,(ULONG)pfnwOldMLEProc);     //pointer to winproc MLE in winword
     //---------------------------------------------------------------------------------------------
     // Load menu and toolbar
     //---------------------------------------------------------------------------------------------
     hwndMenu    = WinLoadMenu(hwndFrame,NULLHANDLE,MAINMENU);      // Load normal window menu
     hwndToolbar = WinLoadMenu(hwndFrame,NULLHANDLE,TOOLBAR);       // Load Toolbar
     //---------------------------------------------------------------------------------------------
     // Set Main window (Frame) size and position
     //---------------------------------------------------------------------------------------------
     WinSetWindowPos(hwndFrame,                     NULLHANDLE,
                     10,10,600,400,
                     SWP_ACTIVATE|SWP_MOVE|
                     SWP_SIZE    |SWP_SHOW);


     WinStartTimer(hab, hwndClient, 1, 100); // Timer for linenr and char pos display in statusbar

     //---------------------------------------------------------------------------------------------
     // Proces drop on icon
     //---------------------------------------------------------------------------------------------
     if (argc > 1)
          OpenFile (argv[1]);


     while (WinGetMsg (hab, &qmsg, 0, 0, 0))
           WinDispatchMsg (hab, &qmsg);

     WinDestroyWindow (hwndFrame);
     WinDestroyMsgQueue (hmq);
     WinTerminate (hab);
     return(0);
     }

//---------------------------------------------------------------------------------------------
// Client window procedure
//---------------------------------------------------------------------------------------------
MRESULT EXPENTRY ClientWndProc (HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
     {
     switch (msg)
          {
          case WM_CREATE:
               WinSetFocus(HWND_DESKTOP, hwndMLE);
          break;

          case WM_SIZE:
               {
               SWP   swpclient;
               WinQueryWindowPos(hwnd, &swpclient);            // Get SWP Client Area.
               WinSetWindowPos(hwndMLE,                        // Place and size MLE
                               HWND_TOP,                       // ONTOP in Z-order
                               0,                              // x coord(precies in de rand!)
                               0,                              // y coord
                               swpclient.cx,                   //
                               swpclient.cy,                   // Size,Place (same as Client Area)
                               SWP_SIZE | SWP_SHOW | SWP_MOVE);// Change size|move en Show
               }
          break;

          case WM_COMMAND:
               {
               switch (SHORT1FROMMP(mp1))
                    {
                    case IDM_NEW:
                         WinSetWindowText(hwndMLE, "");
                         WinSetWindowText(hwndFrame, "Untitled");
                    break;

                    case IDM_OPEN:
                         WinSetWindowText(hwndMLE, "");
                         OpenFileDlg(hwnd);
                    break;

                    case IDM_RETRIEVE:
                         OpenFileDlg(hwnd);
                    break;

                    case IDM_SAVE:
                         {
                         char szTitle[CCHMAXPATH];
                         WinQueryWindowText(hwndFrame, CCHMAXPATH, szTitle);
                         SaveFile(szTitle);
                         }
                    break;

                    case IDM_SAVEAS:
                         {
                         char szTitle[CCHMAXPATH];
                         WinQueryWindowText(hwndFrame, CCHMAXPATH, szTitle);
                         SaveasFileDlg(hwnd);
                         }

                    case IDM_UNDO:
                         WinSendMsg(hwndMLE, MLM_UNDO, 0L, 0L);
                    break;

                    case IDM_CUT:
                         WinSendMsg(hwndMLE, MLM_CUT, 0L, 0L);
                    break;

                    case IDM_COPY:
                         WinSendMsg(hwndMLE, MLM_COPY, 0L, 0L);
                    break;

                    case IDM_PASTE:
                         WinSendMsg(hwndMLE, MLM_PASTE, 0L, 0L);
                    break;

                    case IDM_CLEAR:
                         WinSendMsg(hwndMLE, MLM_CLEAR, 0L, 0L);
                    break;

                    case IDM_EXIT:
                         WinSendMsg(hwnd, WM_CLOSE, 0L, 0L);
                    break;

                    case IDM_ABOUT:
                         WinSetWindowText (hwndStatus, " MLE editor by Eric & Marc (Version2 for EDM/2)");
                    break;
                    }
               }

          case WM_TIMER:
               {
               CHAR      String[64];
               LONG      Line, Col, Position;
               static    LONG OldPosition;

               Position = LONGFROMMR(WinSendMsg(hwndMLE, MLM_QUERYSEL, (MPARAM)MLFQS_CURSORSEL,0L));
               if (Position != OldPosition)
                    {
                    OldPosition = Position;
                    Line = LONGFROMMR(WinSendMsg(hwndMLE, MLM_LINEFROMCHAR, (MPARAM)Position, 0L));
                    Col  = LONGFROMMR(WinSendMsg(hwndMLE, MLM_CHARFROMLINE, (MPARAM)Line, 0L));
                    Col  = Position - Col;
                    sprintf(String,"  Line: %-5d Col: %-5d",Line+1,Col+1);
                    WinSetWindowText(hwndStatus, String);
                    }
               }

          }
     return (WinDefWindowProc (hwnd,msg,mp1,mp2));
     }

//--------------------------------------------------------------------------------------------
//  OpenFileDlg
//
//
//--------------------------------------------------------------------------------------------
void OpenFileDlg(HWND hwndWnd)
	{
     FILEDLG     FileDlg;

     memset(&FileDlg, 0, sizeof(FILEDLG));             // All values in OpenDlg set to 0
     FileDlg.cbSize = sizeof(FILEDLG);                 // Set OpenDlg.cbSize (Mandatory)
     FileDlg.fl     = FDS_OPEN_DIALOG;                 // Set OpenDlg.fl (flags) (Mandatory)
     WinFileDlg(HWND_DESKTOP, hwndWnd, &FileDlg);      // Start Openfiledialog
     if (FileDlg.lReturn == DID_OK)                    // User pressed OK ?
          OpenFile(FileDlg.szFullFile);
     }



//---------------------------------------------------------------------------------------------
// OpenFile  (Function added in EDITOR2 version)
//
// Function fills the main MLE with values from buffer.
// The filename of the file wich contents are in Buffer is writen to the titlebar.
//
// An MLE can't read more than 64 Kb at a time. Thats why this strange do/while is inserted
//---------------------------------------------------------------------------------------------
 void OpenFile (PSZ pszFilename)
     {
     CHAR        *Buffer;                 // input buffer
     HFILE       hfFile ;                 // file handle
     ULONG       Action, BytesRead = 0;   // status control
     CHAR        String[64];              // char string for status message
     IPT         ipt = -1;                // Insertion point

     //---------------------------------------------------------------------
     // Open file
     //---------------------------------------------------------------------
     DosOpen (pszFilename,                // Open file met naam in InFile
              &hfFile,                    // filehandle
              &Action,                    // Action taken by DosOpen
              0,                          // Filesize (not significant, opening existing file)
              FILE_NORMAL,                // Fileattribute (only significant in file creation)
              FILE_OPEN,                  // OPEN ACTION
              OPEN_FLAGS_FAIL_ON_ERROR |  // OPEN MODE
              OPEN_SHARE_DENYWRITE,
              NULL);  				  // NO EA's

     //---------------------------------------------------------------------
     // Read file in MLE
     //---------------------------------------------------------------------
     if (hfFile)
          {
          Buffer = new char[0x8FFF];        // Set up memory for buffer
          WinSendMsg(hwndMLE,               // Set up buffer for MLE
                     MLM_SETIMPORTEXPORT,
                     (MPARAM) Buffer,
                     (MPARAM) 0x8FFF);

          do   {
               DosRead(hfFile, Buffer, 0x8000, &BytesRead);                  // Read buffer
               WinSendMsg(hwndMLE,                                           // Buffer import in MLE
                          MLM_IMPORT,
                          (MPARAM) &ipt,
                          MPFROMLONG(BytesRead));
               sprintf(String," File: %s   Bytes read:%d", pszFilename,ipt); // Stringfill
               WinSetWindowText( hwndStatus, String);                        // Bytesread in statusbar
               }
          while (BytesRead == 0x8000);

          WinSetWindowText(hwndFrame, pszFilename); // Filename in titlebar
          DosClose(hfFile);                         // Close file
          delete Buffer;                            // Free memory
          }
     }

//-------------------------------------------------------------------------------------------
//  SaveasFileDlg  (Function added in EDITOR2 version)
//
//  Saveas filedialog
//-------------------------------------------------------------------------------------------
void SaveasFileDlg(HWND hwndWnd)
     {
     FILEDLG     FileDlg;
     FILESTATUS3 Status;
     APIRET      rc;

     memset(&FileDlg, 0, sizeof(FILEDLG));             // All values in SaveasDlg set to 0
     FileDlg.cbSize = sizeof(FILEDLG);                 // Set SaveasDlg.cbSize (Mandatory)
     FileDlg.fl = FDS_SAVEAS_DIALOG| FDS_ENABLEFILELB; // Set SaveasDlg.fl (flags) (Mandatory)
     WinQueryWindowText(hwndFrame,                     // Query filename from Titlebar
                        CCHMAXPATH,
                        FileDlg.szFullFile);

     WinFileDlg(HWND_DESKTOP, hwndWnd, &FileDlg);      // Start SaveasFiledialog
     if (FileDlg.lReturn == DID_OK)                    // User pressed OK ?
          {
          rc = DosQueryPathInfo(FileDlg.szFullFile,
                                FIL_STANDARD,
                                &Status,
                                sizeof(Status));

          switch (rc)
               {
               case 0:   // File SaveDlg.szFullFile exists
                    {
                    if (WinMessageBox(HWND_DESKTOP, hwndWnd,
                                      "FILE EXISTS! Overwrite ?",
                                      FileDlg.szFullFile,
                                      0, MB_YESNO|MB_QUERY|MB_MOVEABLE) == MBID_YES)
                         {
                         SaveFile(FileDlg.szFullFile);
                         }
                    }
               break;

               case 2:   // File SaveDlg.szFullFile does not exist
                    SaveFile(FileDlg.szFullFile);
               break;

               default:  // An Error occured (most likely 3, path unknown)
                    WinMessageBox(HWND_DESKTOP, hwndWnd,
                                  "Invalid drive,path or file",
                                  "Save as",
                                  0, MB_OK|MB_ICONEXCLAMATION|MB_MOVEABLE);
               break;
               }
          }
     }



//-------------------------------------------------------------------------------------------------
// SaveFile  (Function added in EDITOR2 version)
//
// Function reads the main MLE and fills the buffer.
//
// MLE can't write more than 64 Kb at a time. Thats why this strange do/while is inserted
//-------------------------------------------------------------------------------------------------

void SaveFile (PSZ pszFilename)
     {
     PVOID  Buffer;                            // Transfer buffer
     HFILE  hfFile;                            // File handle
     ULONG  Action, Wrote, amount, amountexp;  //
     IPT    FirstChar = 0;                     // IPT
     LONG   FileLength;                        //
     CHAR   String[64];
     APIRET rc;

     FileLength = (LONG) WinSendMsg(hwndMLE,   // Fetch filelength
                                    MLM_QUERYTEXTLENGTH,
                                    0,
                                    (MPARAM)0xffffffff);
     if(FileLength > 0)                        // Any contents?
           {
           //---------------------------------------------------------------------
           // Open file
           //---------------------------------------------------------------------
           DosOpen(pszFilename,               // Open file met naam in InFile
                   &hfFile,                   // filehandle
                   &Action,                   // Action taken by DosOpen
                   FileLength,                // Filesize (Initial)
                   FILE_NORMAL,               // Fileattribute (only significant in file creation)
                   OPEN_ACTION_CREATE_IF_NEW |// Open Action
                   OPEN_ACTION_REPLACE_IF_EXISTS,
                   OPEN_FLAGS_FAIL_ON_ERROR | // OPEN MODE
                   OPEN_SHARE_DENYREADWRITE|
                   OPEN_ACCESS_READWRITE,
                   NULL);                     // NO EA's

           if (hfFile)
               {
               //---------------------------------------------------------------------
               // Write from MLE to File
               //---------------------------------------------------------------------
               Buffer = new char[0x8FFF];

               WinSendMsg(hwndMLE,
                          MLM_SETIMPORTEXPORT,
                          Buffer,
                          MPFROMLONG(0x8F00));

               do   {
                    amount = 0x8F00;
                    amountexp = (ULONG) WinSendMsg(hwndMLE, MLM_EXPORT, &FirstChar, &amount);
                    DosWrite(hfFile, (PVOID)Buffer, amountexp, &Wrote);
                    sprintf(String," Bytes written: %-10d ", FileLength);
                    WinSetWindowText( hwndStatus, String);
                    }
               while(amountexp != 0);
               WinSetWindowText(hwndFrame, pszFilename);

               delete Buffer;
               DosClose (hfFile) ;
               }
          }
     }

//-------------------------------------------------------------------------------------------------
// NewFrameProc
//
// this proc is coupled through subclassing to the original window proc of the framewindow.
// If the framewindow proc is called, for example if the framewindow is put on the screen,
// this proc is called first. At the end of this subclass the handle  is passed to the
// original proced.
//-------------------------------------------------------------------------------------------------
MRESULT EXPENTRY NewFrameProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
     {
     PFNWP   oldFrameProc ;
     oldFrameProc = (PFNWP) WinQueryWindowULong( hwnd, QWL_USER );      // Pointer from windowword

     switch (msg)
          {
          case WM_QUERYFRAMECTLCOUNT:
               {
               USHORT   itemCount;
               itemCount = SHORT1FROMMR(oldFrameProc(hwnd,msg,mp1,mp2)); //get count of original frame controls
               return ( (MRESULT) (itemCount+2) );                       //add 2 for new controls
               }

           case WM_FORMATFRAME :
               {
               USHORT itemCount = SHORT1FROMMR( oldFrameProc( hwnd, msg, mp1, mp2 ));
               USHORT usClient  = 0,
                      usMinMax  = 0,
                      usToolbar = 0,
                      usMenu    = itemCount,
                      usStatus  = itemCount+1;

               PSWP pSWP = (PSWP)PVOIDFROMMP(mp1);

               while (pSWP[usClient].hwnd != WinWindowFromID(hwndFrame, FID_CLIENT))
                    ++usClient;
               while (pSWP[usToolbar].hwnd != hwndToolbar)
                    ++usToolbar;
               while (pSWP[usMinMax].hwnd != WinWindowFromID(hwndFrame, FID_MINMAX))
                    ++usMinMax;

               // Fill in values for the menu
               pSWP[usMenu].fl = pSWP[usToolbar].fl;     // SWP_SIZE style flag
               pSWP[usMenu].cy = pSWP[usClient].cy;      // Heigth
               pSWP[usMenu].cx = pSWP[usClient].cx ;     // width is menu width
               pSWP[usMenu].hwndInsertBehind = HWND_TOP ;// On which window (ONTOP)
               pSWP[usMenu].hwnd = hwndMenu;             // Window handle

               WinSendMsg(pSWP[usMenu].hwnd,             // let the menu code make the adjustments(cy)
                          WM_ADJUSTWINDOWPOS,            // Message WM_ADJUSTWINDOWPOS to hwndTool
                          MPFROMP(pSWP+usMenu),          // mp1 == SWP struct of hwndTool
                          (MPARAM) 0L );                 // mp2 == Leeg */

               pSWP[usMenu].x = pSWP[usToolbar].x ;                                        // XPOS in FRAME
               pSWP[usMenu].y = pSWP[usToolbar].y + pSWP[usToolbar].cy - pSWP[usMenu].cy ; // YPOS in FRAME

               pSWP[usToolbar].y = pSWP[usMenu].y - pSWP[usToolbar].cy;

               // adjust client window size for 2nd menu
               // If not, the client window will be placed over the statusbar

               pSWP[usClient].cy= pSWP[usClient].cy - pSWP[usMenu].cy ;

               // Fill in values for the statusbar
               pSWP[usStatus].fl = SWP_SIZE | SWP_MOVE;      // SWP_SIZE style flag

               // get a presentation space for our statusbar
               HPS hpsTemp = WinGetPS(hwndStatus);
               FONTMETRICS fm;
               GpiQueryFontMetrics(hpsTemp, sizeof(FONTMETRICS), &fm);
               WinReleasePS(hpsTemp);

               // use font metrics to adjust hight
               pSWP[usStatus].cy = fm.lMaxBaselineExt;

               //pSWP[usStatus].cy = pSWP[usMinMax].cy;        // Heigth menu hoogte
               pSWP[usStatus].cx = pSWP[usToolbar].cx ;      // width is menu width
               pSWP[usStatus].x = pSWP[usClient].x ;         // XPOS in FRAME
               pSWP[usStatus].y = pSWP[usClient].y ;         // YPOS in FRAME
               pSWP[usStatus].hwndInsertBehind = HWND_TOP ;  // On which window (ONTOP)
               pSWP[usStatus].hwnd = hwndStatus;             // Window handle
               // adjust client window size for 2nd control
               // If not, the client window will be placed over the statusbar
               pSWP[usClient].cy= pSWP[usClient].cy - pSWP[usStatus].cy ;
               pSWP[usClient].y = pSWP[usStatus].y  + pSWP[usStatus].cy ;
               // return total count of frame controls
               return( MRFROMSHORT(itemCount+2));
               }

          default:
               return oldFrameProc(hwnd,msg,mp1,mp2);
          }
     }

//--------------------------------------------------------------------------------------------------
// Subclass for MLE (nodig voor drag drop)  (Function added in EDITOR2 version)
//
// It is neccesery to subclass the MLE window to install drag & drop for opening files.
//
// DM_RENDER isn't send to the source because owning a filename and a sourcedir is enough
// Confed itself will open the file. It's not nessecery to use filesystem rendering!
//--------------------------------------------------------------------------------------------------
MRESULT EXPENTRY NewMLEProc(HWND hwndDlg, ULONG msg, MPARAM mpParm1, MPARAM mpParm2)
	{
	PFNWP     oldMLEProc;
     PDRAGINFO pDragInfo;
     PDRAGITEM pDragItem;

	oldMLEProc = (PFNWP) WinQueryWindowULong(hwndDlg, QWL_USER); // Get Winproc pointer from winword

     switch (msg)
          {
          case DM_DRAGOVER:
	          {
          	pDragInfo = (PDRAGINFO) mpParm1;
          	DrgAccessDraginfo( pDragInfo );
          	pDragItem = DrgQueryDragitemPtr( pDragInfo, 0 );
          	//---------------------------------------------------------------
          	// Don't accept multi select and non_text
          	//---------------------------------------------------------------
               if (pDragInfo->cditem > 1 || !DrgVerifyType(pDragItem, DRT_TEXT))
		          return ( MPFROM2SHORT (DOR_NEVERDROP, DO_UNKNOWN) );
          	else
          		return ( MPFROM2SHORT (DOR_DROP, DO_UNKNOWN) );
          	}

          case DM_DROP:
               {
               UCHAR dragname[CCHMAXPATH];
               pDragInfo = (PDRAGINFO)mpParm1;
               DrgAccessDraginfo(pDragInfo);
               pDragItem = DrgQueryDragitemPtr(pDragInfo, 0);

               DrgQueryStrName(pDragItem->hstrContainerName,100,dragname);
               DrgQueryStrName(pDragItem->hstrSourceName,100,dragname+strlen(dragname));
               OpenFile(dragname);
               }
          break;
          }
     return oldMLEProc(hwndDlg, msg, mpParm1, mpParm2);
     }

